require_relative 'spec_helper'

describe RecommenderCore::Handler do
  let(:engine_data) { engine_data_sample }
  let(:hash_user_based) { { similarity_metric: 'PearsonCorrelationSimilarity', neighborhood: 5, recommender_algo: 'GenericUserBasedRecommender', engine_data: engine_data }  }
  let(:hash_item_based) { { similarity_metric: 'PearsonCorrelationSimilarity', neighborhood: 5, recommender_algo: 'GenericItemBasedRecommender', engine_data: engine_data }  }
  let(:params_user_based) { {hash: hash_user_based, id: 1, nb_wanted: 2, rescorer: nil} }
  let(:params_item_based) { {hash: hash_item_based, id: 1, nb_wanted: 2, rescorer: nil} }
  let(:evaluation) { {hash: hash_item_based, training_prcentage: 0.7, eval_prcentage: 0.3} }
  let(:estimation) { {hash: hash_user_based, user_id: 1, item_id: 3} }

  describe ".init_recommender" do
    it { expect(RecommenderCore::Handler.init_recommender(hash_user_based)).to_not be_nil }
    it { expect(RecommenderCore::Handler.init_recommender(hash_item_based).class).to eq(JrubyMahout::Recommender) }
    it { expect(RecommenderCore::Handler.init_recommender(hash_user_based).data_model).to_not be_nil }
  end

  describe ".data_to_csv" do
    it { expect(RecommenderCore::Handler.data_to_csv(engine_data).class).to eq(File) }
  end

  describe '.similar_users' do
    it { expect(RecommenderCore::Handler.similar_users(params_user_based)).to_not be_nil }
  end

  describe '.similar_items' do
    it { expect(RecommenderCore::Handler.similar_items(params_item_based)).to_not be_nil }
    it { expect(RecommenderCore::Handler.similar_items(params_item_based).class).to eq Array }
  end

  describe '.recommend_items' do
    it { expect(RecommenderCore::Handler.recommend_items(params_user_based)).to_not be_nil }
  end

  describe '.evaluate' do
    it { expect(RecommenderCore::Handler.evaluate(evaluation)).to_not be_nil }
  end

  describe '.estimate_preference' do
    it { expect(RecommenderCore::Handler.estimate_preference(estimation)).to_not be_nil }
  end
end
